# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr, validator
from authentik_client.models.policy_engine_mode import PolicyEngineMode
from authentik_client.models.provider import Provider

class Application(BaseModel):
    """
    Application Serializer  # noqa: E501
    """
    pk: StrictStr = Field(...)
    name: StrictStr = Field(..., description="Application's display Name.")
    slug: constr(strict=True, max_length=50) = Field(..., description="Internal application name, used in URLs.")
    provider: Optional[StrictInt] = None
    provider_obj: Provider = Field(...)
    backchannel_providers: Optional[conlist(StrictInt)] = None
    backchannel_providers_obj: conlist(Provider) = Field(...)
    launch_url: Optional[StrictStr] = Field(..., description="Allow formatting of launch URL")
    open_in_new_tab: Optional[StrictBool] = Field(None, description="Open launch URL in a new browser tab or window.")
    meta_launch_url: Optional[StrictStr] = None
    meta_icon: Optional[StrictStr] = Field(..., description="Get the URL to the App Icon image. If the name is /static or starts with http it is returned as-is")
    meta_description: Optional[StrictStr] = None
    meta_publisher: Optional[StrictStr] = None
    policy_engine_mode: Optional[PolicyEngineMode] = None
    group: Optional[StrictStr] = None
    __properties = ["pk", "name", "slug", "provider", "provider_obj", "backchannel_providers", "backchannel_providers_obj", "launch_url", "open_in_new_tab", "meta_launch_url", "meta_icon", "meta_description", "meta_publisher", "policy_engine_mode", "group"]

    @validator('slug')
    def slug_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[-a-zA-Z0-9_]+$", value):
            raise ValueError(r"must validate the regular expression /^[-a-zA-Z0-9_]+$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Application:
        """Create an instance of Application from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "pk",
                            "provider_obj",
                            "backchannel_providers_obj",
                            "launch_url",
                            "meta_icon",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of provider_obj
        if self.provider_obj:
            _dict['provider_obj'] = self.provider_obj.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in backchannel_providers_obj (list)
        _items = []
        if self.backchannel_providers_obj:
            for _item in self.backchannel_providers_obj:
                if _item:
                    _items.append(_item.to_dict())
            _dict['backchannel_providers_obj'] = _items
        # set to None if provider (nullable) is None
        # and __fields_set__ contains the field
        if self.provider is None and "provider" in self.__fields_set__:
            _dict['provider'] = None

        # set to None if launch_url (nullable) is None
        # and __fields_set__ contains the field
        if self.launch_url is None and "launch_url" in self.__fields_set__:
            _dict['launch_url'] = None

        # set to None if meta_icon (nullable) is None
        # and __fields_set__ contains the field
        if self.meta_icon is None and "meta_icon" in self.__fields_set__:
            _dict['meta_icon'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Application:
        """Create an instance of Application from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Application.parse_obj(obj)

        _obj = Application.parse_obj({
            "pk": obj.get("pk"),
            "name": obj.get("name"),
            "slug": obj.get("slug"),
            "provider": obj.get("provider"),
            "provider_obj": Provider.from_dict(obj.get("provider_obj")) if obj.get("provider_obj") is not None else None,
            "backchannel_providers": obj.get("backchannel_providers"),
            "backchannel_providers_obj": [Provider.from_dict(_item) for _item in obj.get("backchannel_providers_obj")] if obj.get("backchannel_providers_obj") is not None else None,
            "launch_url": obj.get("launch_url"),
            "open_in_new_tab": obj.get("open_in_new_tab"),
            "meta_launch_url": obj.get("meta_launch_url"),
            "meta_icon": obj.get("meta_icon"),
            "meta_description": obj.get("meta_description"),
            "meta_publisher": obj.get("meta_publisher"),
            "policy_engine_mode": obj.get("policy_engine_mode"),
            "group": obj.get("group")
        })
        return _obj


