# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr

class BlueprintInstanceRequest(BaseModel):
    """
    Info about a single blueprint instance file  # noqa: E501
    """
    name: constr(strict=True, min_length=1) = Field(...)
    path: Optional[StrictStr] = ''
    context: Optional[Any] = None
    enabled: Optional[StrictBool] = None
    content: Optional[StrictStr] = None
    __properties = ["name", "path", "context", "enabled", "content"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BlueprintInstanceRequest:
        """Create an instance of BlueprintInstanceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if context (nullable) is None
        # and __fields_set__ contains the field
        if self.context is None and "context" in self.__fields_set__:
            _dict['context'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BlueprintInstanceRequest:
        """Create an instance of BlueprintInstanceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BlueprintInstanceRequest.parse_obj(obj)

        _obj = BlueprintInstanceRequest.parse_obj({
            "name": obj.get("name"),
            "path": obj.get("path") if obj.get("path") is not None else '',
            "context": obj.get("context"),
            "enabled": obj.get("enabled"),
            "content": obj.get("content")
        })
        return _obj


