# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from authentik_client.models.challenge_choices import ChallengeChoices
from authentik_client.models.consent_permission import ConsentPermission
from authentik_client.models.contextual_flow_info import ContextualFlowInfo
from authentik_client.models.error_detail import ErrorDetail

class ConsentChallenge(BaseModel):
    """
    Challenge info for consent screens  # noqa: E501
    """
    type: ChallengeChoices = Field(...)
    flow_info: Optional[ContextualFlowInfo] = None
    component: Optional[StrictStr] = 'ak-stage-consent'
    response_errors: Optional[Dict[str, conlist(ErrorDetail)]] = None
    pending_user: StrictStr = Field(...)
    pending_user_avatar: StrictStr = Field(...)
    header_text: Optional[StrictStr] = None
    permissions: conlist(ConsentPermission) = Field(...)
    additional_permissions: conlist(ConsentPermission) = Field(...)
    token: StrictStr = Field(...)
    __properties = ["type", "flow_info", "component", "response_errors", "pending_user", "pending_user_avatar", "header_text", "permissions", "additional_permissions", "token"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ConsentChallenge:
        """Create an instance of ConsentChallenge from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of flow_info
        if self.flow_info:
            _dict['flow_info'] = self.flow_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in response_errors (dict of array)
        _field_dict_of_array = {}
        if self.response_errors:
            for _key in self.response_errors:
                if self.response_errors[_key]:
                    _field_dict_of_array[_key] = [
                        _item.to_dict() for _item in self.response_errors[_key]
                    ]
            _dict['response_errors'] = _field_dict_of_array
        # override the default output from pydantic by calling `to_dict()` of each item in permissions (list)
        _items = []
        if self.permissions:
            for _item in self.permissions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['permissions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in additional_permissions (list)
        _items = []
        if self.additional_permissions:
            for _item in self.additional_permissions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['additional_permissions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ConsentChallenge:
        """Create an instance of ConsentChallenge from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ConsentChallenge.parse_obj(obj)

        _obj = ConsentChallenge.parse_obj({
            "type": obj.get("type"),
            "flow_info": ContextualFlowInfo.from_dict(obj.get("flow_info")) if obj.get("flow_info") is not None else None,
            "component": obj.get("component") if obj.get("component") is not None else 'ak-stage-consent',
            "response_errors": dict(
                (_k,
                        [ErrorDetail.from_dict(_item) for _item in _v]
                        if _v is not None
                        else None
                )
                for _k, _v in obj.get("response_errors").items()
            ),
            "pending_user": obj.get("pending_user"),
            "pending_user_avatar": obj.get("pending_user_avatar"),
            "header_text": obj.get("header_text"),
            "permissions": [ConsentPermission.from_dict(_item) for _item in obj.get("permissions")] if obj.get("permissions") is not None else None,
            "additional_permissions": [ConsentPermission.from_dict(_item) for _item in obj.get("additional_permissions")] if obj.get("additional_permissions") is not None else None,
            "token": obj.get("token")
        })
        return _obj


