# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from authentik_client.models.challenge_choices import ChallengeChoices
from authentik_client.models.contextual_flow_info import ContextualFlowInfo
from authentik_client.models.error_detail import ErrorDetail
from authentik_client.models.login_source import LoginSource

class IdentificationChallenge(BaseModel):
    """
    Identification challenges with all UI elements  # noqa: E501
    """
    type: ChallengeChoices = Field(...)
    flow_info: Optional[ContextualFlowInfo] = None
    component: Optional[StrictStr] = 'ak-stage-identification'
    response_errors: Optional[Dict[str, conlist(ErrorDetail)]] = None
    user_fields: Optional[conlist(StrictStr)] = Field(...)
    password_fields: StrictBool = Field(...)
    application_pre: Optional[StrictStr] = None
    enroll_url: Optional[StrictStr] = None
    recovery_url: Optional[StrictStr] = None
    passwordless_url: Optional[StrictStr] = None
    primary_action: StrictStr = Field(...)
    sources: Optional[conlist(LoginSource)] = None
    show_source_labels: StrictBool = Field(...)
    __properties = ["type", "flow_info", "component", "response_errors", "user_fields", "password_fields", "application_pre", "enroll_url", "recovery_url", "passwordless_url", "primary_action", "sources", "show_source_labels"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IdentificationChallenge:
        """Create an instance of IdentificationChallenge from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of flow_info
        if self.flow_info:
            _dict['flow_info'] = self.flow_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each value in response_errors (dict of array)
        _field_dict_of_array = {}
        if self.response_errors:
            for _key in self.response_errors:
                if self.response_errors[_key]:
                    _field_dict_of_array[_key] = [
                        _item.to_dict() for _item in self.response_errors[_key]
                    ]
            _dict['response_errors'] = _field_dict_of_array
        # override the default output from pydantic by calling `to_dict()` of each item in sources (list)
        _items = []
        if self.sources:
            for _item in self.sources:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sources'] = _items
        # set to None if user_fields (nullable) is None
        # and __fields_set__ contains the field
        if self.user_fields is None and "user_fields" in self.__fields_set__:
            _dict['user_fields'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IdentificationChallenge:
        """Create an instance of IdentificationChallenge from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IdentificationChallenge.parse_obj(obj)

        _obj = IdentificationChallenge.parse_obj({
            "type": obj.get("type"),
            "flow_info": ContextualFlowInfo.from_dict(obj.get("flow_info")) if obj.get("flow_info") is not None else None,
            "component": obj.get("component") if obj.get("component") is not None else 'ak-stage-identification',
            "response_errors": dict(
                (_k,
                        [ErrorDetail.from_dict(_item) for _item in _v]
                        if _v is not None
                        else None
                )
                for _k, _v in obj.get("response_errors").items()
            ),
            "user_fields": obj.get("user_fields"),
            "password_fields": obj.get("password_fields"),
            "application_pre": obj.get("application_pre"),
            "enroll_url": obj.get("enroll_url"),
            "recovery_url": obj.get("recovery_url"),
            "passwordless_url": obj.get("passwordless_url"),
            "primary_action": obj.get("primary_action"),
            "sources": [LoginSource.from_dict(_item) for _item in obj.get("sources")] if obj.get("sources") is not None else None,
            "show_source_labels": obj.get("show_source_labels")
        })
        return _obj


