# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictBool, conlist
from authentik_client.models.system_task import SystemTask

class LDAPSyncStatus(BaseModel):
    """
    LDAP Source sync status  # noqa: E501
    """
    is_running: StrictBool = Field(...)
    tasks: conlist(SystemTask) = Field(...)
    __properties = ["is_running", "tasks"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LDAPSyncStatus:
        """Create an instance of LDAPSyncStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "is_running",
                            "tasks",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in tasks (list)
        _items = []
        if self.tasks:
            for _item in self.tasks:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tasks'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LDAPSyncStatus:
        """Create an instance of LDAPSyncStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LDAPSyncStatus.parse_obj(obj)

        _obj = LDAPSyncStatus.parse_obj({
            "is_running": obj.get("is_running"),
            "tasks": [SystemTask.from_dict(_item) for _item in obj.get("tasks")] if obj.get("tasks") is not None else None
        })
        return _obj


