# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from authentik_client.models.event import Event
from authentik_client.models.severity_enum import SeverityEnum

class Notification(BaseModel):
    """
    Notification Serializer  # noqa: E501
    """
    pk: StrictStr = Field(...)
    severity: SeverityEnum = Field(...)
    body: StrictStr = Field(...)
    created: datetime = Field(...)
    event: Optional[Event] = None
    seen: Optional[StrictBool] = None
    __properties = ["pk", "severity", "body", "created", "event", "seen"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Notification:
        """Create an instance of Notification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "pk",
                            "severity",
                            "body",
                            "created",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of event
        if self.event:
            _dict['event'] = self.event.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Notification:
        """Create an instance of Notification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Notification.parse_obj(obj)

        _obj = Notification.parse_obj({
            "pk": obj.get("pk"),
            "severity": obj.get("severity"),
            "body": obj.get("body"),
            "created": obj.get("created"),
            "event": Event.from_dict(obj.get("event")) if obj.get("event") is not None else None,
            "seen": obj.get("seen")
        })
        return _obj


