# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist, constr
from authentik_client.models.outpost_type_enum import OutpostTypeEnum

class OutpostRequest(BaseModel):
    """
    Outpost Serializer  # noqa: E501
    """
    name: constr(strict=True, min_length=1) = Field(...)
    type: OutpostTypeEnum = Field(...)
    providers: conlist(StrictInt) = Field(...)
    service_connection: Optional[StrictStr] = Field(None, description="Select Service-Connection authentik should use to manage this outpost. Leave empty if authentik should not handle the deployment.")
    config: Dict[str, Any] = Field(...)
    managed: Optional[constr(strict=True, min_length=1)] = Field(None, description="Objects that are managed by authentik. These objects are created and updated automatically. This flag only indicates that an object can be overwritten by migrations. You can still modify the objects via the API, but expect changes to be overwritten in a later update.")
    __properties = ["name", "type", "providers", "service_connection", "config", "managed"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OutpostRequest:
        """Create an instance of OutpostRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if service_connection (nullable) is None
        # and __fields_set__ contains the field
        if self.service_connection is None and "service_connection" in self.__fields_set__:
            _dict['service_connection'] = None

        # set to None if managed (nullable) is None
        # and __fields_set__ contains the field
        if self.managed is None and "managed" in self.__fields_set__:
            _dict['managed'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OutpostRequest:
        """Create an instance of OutpostRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OutpostRequest.parse_obj(obj)

        _obj = OutpostRequest.parse_obj({
            "name": obj.get("name"),
            "type": obj.get("type"),
            "providers": obj.get("providers"),
            "service_connection": obj.get("service_connection"),
            "config": obj.get("config"),
            "managed": obj.get("managed")
        })
        return _obj


