# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conint, conlist, constr
from authentik_client.models.backends_enum import BackendsEnum
from authentik_client.models.flow_set_request import FlowSetRequest

class PasswordStageRequest(BaseModel):
    """
    PasswordStage Serializer  # noqa: E501
    """
    name: constr(strict=True, min_length=1) = Field(...)
    flow_set: Optional[conlist(FlowSetRequest)] = None
    backends: conlist(BackendsEnum) = Field(..., description="Selection of backends to test the password against.")
    configure_flow: Optional[StrictStr] = Field(None, description="Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage.")
    failed_attempts_before_cancel: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = Field(None, description="How many attempts a user has before the flow is canceled. To lock the user out, use a reputation policy and a user_write stage.")
    __properties = ["name", "flow_set", "backends", "configure_flow", "failed_attempts_before_cancel"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PasswordStageRequest:
        """Create an instance of PasswordStageRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in flow_set (list)
        _items = []
        if self.flow_set:
            for _item in self.flow_set:
                if _item:
                    _items.append(_item.to_dict())
            _dict['flow_set'] = _items
        # set to None if configure_flow (nullable) is None
        # and __fields_set__ contains the field
        if self.configure_flow is None and "configure_flow" in self.__fields_set__:
            _dict['configure_flow'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PasswordStageRequest:
        """Create an instance of PasswordStageRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PasswordStageRequest.parse_obj(obj)

        _obj = PasswordStageRequest.parse_obj({
            "name": obj.get("name"),
            "flow_set": [FlowSetRequest.from_dict(_item) for _item in obj.get("flow_set")] if obj.get("flow_set") is not None else None,
            "backends": obj.get("backends"),
            "configure_flow": obj.get("configure_flow"),
            "failed_attempts_before_cancel": obj.get("failed_attempts_before_cancel")
        })
        return _obj


