# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint, conlist, constr
from authentik_client.models.flow_set_request import FlowSetRequest

class PatchedEmailStageRequest(BaseModel):
    """
    EmailStage Serializer  # noqa: E501
    """
    name: Optional[constr(strict=True, min_length=1)] = None
    flow_set: Optional[conlist(FlowSetRequest)] = None
    use_global_settings: Optional[StrictBool] = Field(None, description="When enabled, global Email connection settings will be used and connection settings below will be ignored.")
    host: Optional[constr(strict=True, min_length=1)] = None
    port: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = None
    username: Optional[StrictStr] = None
    password: Optional[StrictStr] = None
    use_tls: Optional[StrictBool] = None
    use_ssl: Optional[StrictBool] = None
    timeout: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = None
    from_address: Optional[constr(strict=True, max_length=254, min_length=1)] = None
    token_expiry: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = Field(None, description="Time in minutes the token sent is valid.")
    subject: Optional[constr(strict=True, min_length=1)] = None
    template: Optional[constr(strict=True, min_length=1)] = None
    activate_user_on_success: Optional[StrictBool] = Field(None, description="Activate users upon completion of stage.")
    __properties = ["name", "flow_set", "use_global_settings", "host", "port", "username", "password", "use_tls", "use_ssl", "timeout", "from_address", "token_expiry", "subject", "template", "activate_user_on_success"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedEmailStageRequest:
        """Create an instance of PatchedEmailStageRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in flow_set (list)
        _items = []
        if self.flow_set:
            for _item in self.flow_set:
                if _item:
                    _items.append(_item.to_dict())
            _dict['flow_set'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedEmailStageRequest:
        """Create an instance of PatchedEmailStageRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedEmailStageRequest.parse_obj(obj)

        _obj = PatchedEmailStageRequest.parse_obj({
            "name": obj.get("name"),
            "flow_set": [FlowSetRequest.from_dict(_item) for _item in obj.get("flow_set")] if obj.get("flow_set") is not None else None,
            "use_global_settings": obj.get("use_global_settings"),
            "host": obj.get("host"),
            "port": obj.get("port"),
            "username": obj.get("username"),
            "password": obj.get("password"),
            "use_tls": obj.get("use_tls"),
            "use_ssl": obj.get("use_ssl"),
            "timeout": obj.get("timeout"),
            "from_address": obj.get("from_address"),
            "token_expiry": obj.get("token_expiry"),
            "subject": obj.get("subject"),
            "template": obj.get("template"),
            "activate_user_on_success": obj.get("activate_user_on_success")
        })
        return _obj


