# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr, conint, conlist, constr
from authentik_client.models.auth_mode_enum import AuthModeEnum
from authentik_client.models.protocol_enum import ProtocolEnum

class PatchedEndpointRequest(BaseModel):
    """
    Endpoint Serializer  # noqa: E501
    """
    name: Optional[constr(strict=True, min_length=1)] = None
    provider: Optional[StrictInt] = None
    protocol: Optional[ProtocolEnum] = None
    host: Optional[constr(strict=True, min_length=1)] = None
    settings: Optional[Any] = None
    property_mappings: Optional[conlist(StrictStr)] = None
    auth_mode: Optional[AuthModeEnum] = None
    maximum_connections: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = None
    __properties = ["name", "provider", "protocol", "host", "settings", "property_mappings", "auth_mode", "maximum_connections"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedEndpointRequest:
        """Create an instance of PatchedEndpointRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if settings (nullable) is None
        # and __fields_set__ contains the field
        if self.settings is None and "settings" in self.__fields_set__:
            _dict['settings'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedEndpointRequest:
        """Create an instance of PatchedEndpointRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedEndpointRequest.parse_obj(obj)

        _obj = PatchedEndpointRequest.parse_obj({
            "name": obj.get("name"),
            "provider": obj.get("provider"),
            "protocol": obj.get("protocol"),
            "host": obj.get("host"),
            "settings": obj.get("settings"),
            "property_mappings": obj.get("property_mappings"),
            "auth_mode": obj.get("auth_mode"),
            "maximum_connections": obj.get("maximum_connections")
        })
        return _obj


