# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Optional
from pydantic import BaseModel, Field, StrictBool, constr

class PatchedKubernetesServiceConnectionRequest(BaseModel):
    """
    KubernetesServiceConnection Serializer  # noqa: E501
    """
    name: Optional[constr(strict=True, min_length=1)] = None
    local: Optional[StrictBool] = Field(None, description="If enabled, use the local connection. Required Docker socket/Kubernetes Integration")
    kubeconfig: Optional[Any] = Field(None, description="Paste your kubeconfig here. authentik will automatically use the currently selected context.")
    verify_ssl: Optional[StrictBool] = Field(None, description="Verify SSL Certificates of the Kubernetes API endpoint")
    __properties = ["name", "local", "kubeconfig", "verify_ssl"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedKubernetesServiceConnectionRequest:
        """Create an instance of PatchedKubernetesServiceConnectionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if kubeconfig (nullable) is None
        # and __fields_set__ contains the field
        if self.kubeconfig is None and "kubeconfig" in self.__fields_set__:
            _dict['kubeconfig'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedKubernetesServiceConnectionRequest:
        """Create an instance of PatchedKubernetesServiceConnectionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedKubernetesServiceConnectionRequest.parse_obj(obj)

        _obj = PatchedKubernetesServiceConnectionRequest.parse_obj({
            "name": obj.get("name"),
            "local": obj.get("local"),
            "kubeconfig": obj.get("kubeconfig"),
            "verify_ssl": obj.get("verify_ssl")
        })
        return _obj


