# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, constr
from authentik_client.models.severity_enum import SeverityEnum

class PatchedNotificationRuleRequest(BaseModel):
    """
    NotificationRule Serializer  # noqa: E501
    """
    name: Optional[constr(strict=True, min_length=1)] = None
    transports: Optional[conlist(StrictStr)] = Field(None, description="Select which transports should be used to notify the user. If none are selected, the notification will only be shown in the authentik UI.")
    severity: Optional[SeverityEnum] = Field(None, description="Controls which severity level the created notifications will have.")
    group: Optional[StrictStr] = Field(None, description="Define which group of users this notification should be sent and shown to. If left empty, Notification won't ben sent.")
    __properties = ["name", "transports", "severity", "group"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedNotificationRuleRequest:
        """Create an instance of PatchedNotificationRuleRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if group (nullable) is None
        # and __fields_set__ contains the field
        if self.group is None and "group" in self.__fields_set__:
            _dict['group'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedNotificationRuleRequest:
        """Create an instance of PatchedNotificationRuleRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedNotificationRuleRequest.parse_obj(obj)

        _obj = PatchedNotificationRuleRequest.parse_obj({
            "name": obj.get("name"),
            "transports": obj.get("transports"),
            "severity": obj.get("severity"),
            "group": obj.get("group")
        })
        return _obj


