# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conint

class PatchedPolicyBindingRequest(BaseModel):
    """
    PolicyBinding Serializer  # noqa: E501
    """
    policy: Optional[StrictStr] = None
    group: Optional[StrictStr] = None
    user: Optional[StrictInt] = None
    target: Optional[StrictStr] = None
    negate: Optional[StrictBool] = Field(None, description="Negates the outcome of the policy. Messages are unaffected.")
    enabled: Optional[StrictBool] = None
    order: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = None
    timeout: Optional[conint(strict=True, le=2147483647, ge=0)] = Field(None, description="Timeout after which Policy execution is terminated.")
    failure_result: Optional[StrictBool] = Field(None, description="Result if the Policy execution fails.")
    __properties = ["policy", "group", "user", "target", "negate", "enabled", "order", "timeout", "failure_result"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedPolicyBindingRequest:
        """Create an instance of PatchedPolicyBindingRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if policy (nullable) is None
        # and __fields_set__ contains the field
        if self.policy is None and "policy" in self.__fields_set__:
            _dict['policy'] = None

        # set to None if group (nullable) is None
        # and __fields_set__ contains the field
        if self.group is None and "group" in self.__fields_set__:
            _dict['group'] = None

        # set to None if user (nullable) is None
        # and __fields_set__ contains the field
        if self.user is None and "user" in self.__fields_set__:
            _dict['user'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedPolicyBindingRequest:
        """Create an instance of PatchedPolicyBindingRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedPolicyBindingRequest.parse_obj(obj)

        _obj = PatchedPolicyBindingRequest.parse_obj({
            "policy": obj.get("policy"),
            "group": obj.get("group"),
            "user": obj.get("user"),
            "target": obj.get("target"),
            "negate": obj.get("negate"),
            "enabled": obj.get("enabled"),
            "order": obj.get("order"),
            "timeout": obj.get("timeout"),
            "failure_result": obj.get("failure_result")
        })
        return _obj


