# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, conint, constr

class PatchedReputationPolicyRequest(BaseModel):
    """
    Reputation Policy Serializer  # noqa: E501
    """
    name: Optional[constr(strict=True, min_length=1)] = None
    execution_logging: Optional[StrictBool] = Field(None, description="When this option is enabled, all executions of this policy will be logged. By default, only execution errors are logged.")
    check_ip: Optional[StrictBool] = None
    check_username: Optional[StrictBool] = None
    threshold: Optional[conint(strict=True, le=2147483647, ge=-2147483648)] = None
    __properties = ["name", "execution_logging", "check_ip", "check_username", "threshold"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedReputationPolicyRequest:
        """Create an instance of PatchedReputationPolicyRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedReputationPolicyRequest:
        """Create an instance of PatchedReputationPolicyRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedReputationPolicyRequest.parse_obj(obj)

        _obj = PatchedReputationPolicyRequest.parse_obj({
            "name": obj.get("name"),
            "execution_logging": obj.get("execution_logging"),
            "check_ip": obj.get("check_ip"),
            "check_username": obj.get("check_username"),
            "threshold": obj.get("threshold")
        })
        return _obj


