# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr

class PatchedSAMLPropertyMappingRequest(BaseModel):
    """
    SAMLPropertyMapping Serializer  # noqa: E501
    """
    managed: Optional[constr(strict=True, min_length=1)] = Field(None, description="Objects that are managed by authentik. These objects are created and updated automatically. This flag only indicates that an object can be overwritten by migrations. You can still modify the objects via the API, but expect changes to be overwritten in a later update.")
    name: Optional[constr(strict=True, min_length=1)] = None
    expression: Optional[constr(strict=True, min_length=1)] = None
    saml_name: Optional[constr(strict=True, min_length=1)] = None
    friendly_name: Optional[StrictStr] = None
    __properties = ["managed", "name", "expression", "saml_name", "friendly_name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedSAMLPropertyMappingRequest:
        """Create an instance of PatchedSAMLPropertyMappingRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if managed (nullable) is None
        # and __fields_set__ contains the field
        if self.managed is None and "managed" in self.__fields_set__:
            _dict['managed'] = None

        # set to None if friendly_name (nullable) is None
        # and __fields_set__ contains the field
        if self.friendly_name is None and "friendly_name" in self.__fields_set__:
            _dict['friendly_name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedSAMLPropertyMappingRequest:
        """Create an instance of PatchedSAMLPropertyMappingRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedSAMLPropertyMappingRequest.parse_obj(obj)

        _obj = PatchedSAMLPropertyMappingRequest.parse_obj({
            "managed": obj.get("managed"),
            "name": obj.get("name"),
            "expression": obj.get("expression"),
            "saml_name": obj.get("saml_name"),
            "friendly_name": obj.get("friendly_name")
        })
        return _obj


