# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist, constr
from authentik_client.models.flow_set_request import FlowSetRequest
from authentik_client.models.geoip_binding_enum import GeoipBindingEnum
from authentik_client.models.network_binding_enum import NetworkBindingEnum

class PatchedUserLoginStageRequest(BaseModel):
    """
    UserLoginStage Serializer  # noqa: E501
    """
    name: Optional[constr(strict=True, min_length=1)] = None
    flow_set: Optional[conlist(FlowSetRequest)] = None
    session_duration: Optional[constr(strict=True, min_length=1)] = Field(None, description="Determines how long a session lasts. Default of 0 means that the sessions lasts until the browser is closed. (Format: hours=-1;minutes=-2;seconds=-3)")
    terminate_other_sessions: Optional[StrictBool] = Field(None, description="Terminate all other sessions of the user logging in.")
    remember_me_offset: Optional[constr(strict=True, min_length=1)] = Field(None, description="Offset the session will be extended by when the user picks the remember me option. Default of 0 means that the remember me option will not be shown. (Format: hours=-1;minutes=-2;seconds=-3)")
    network_binding: Optional[NetworkBindingEnum] = Field(None, description="Bind sessions created by this stage to the configured network")
    geoip_binding: Optional[GeoipBindingEnum] = Field(None, description="Bind sessions created by this stage to the configured GeoIP location")
    __properties = ["name", "flow_set", "session_duration", "terminate_other_sessions", "remember_me_offset", "network_binding", "geoip_binding"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedUserLoginStageRequest:
        """Create an instance of PatchedUserLoginStageRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in flow_set (list)
        _items = []
        if self.flow_set:
            for _item in self.flow_set:
                if _item:
                    _items.append(_item.to_dict())
            _dict['flow_set'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedUserLoginStageRequest:
        """Create an instance of PatchedUserLoginStageRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedUserLoginStageRequest.parse_obj(obj)

        _obj = PatchedUserLoginStageRequest.parse_obj({
            "name": obj.get("name"),
            "flow_set": [FlowSetRequest.from_dict(_item) for _item in obj.get("flow_set")] if obj.get("flow_set") is not None else None,
            "session_duration": obj.get("session_duration"),
            "terminate_other_sessions": obj.get("terminate_other_sessions"),
            "remember_me_offset": obj.get("remember_me_offset"),
            "network_binding": obj.get("network_binding"),
            "geoip_binding": obj.get("geoip_binding")
        })
        return _obj


