# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class RACProvider(BaseModel):
    """
    RACProvider Serializer  # noqa: E501
    """
    pk: StrictInt = Field(...)
    name: StrictStr = Field(...)
    authentication_flow: Optional[StrictStr] = Field(None, description="Flow used for authentication when the associated application is accessed by an un-authenticated user.")
    authorization_flow: StrictStr = Field(..., description="Flow used when authorizing this provider.")
    property_mappings: Optional[conlist(StrictStr)] = None
    component: StrictStr = Field(..., description="Get object component so that we know how to edit the object")
    assigned_application_slug: StrictStr = Field(..., description="Internal application name, used in URLs.")
    assigned_application_name: StrictStr = Field(..., description="Application's display Name.")
    assigned_backchannel_application_slug: StrictStr = Field(..., description="Internal application name, used in URLs.")
    assigned_backchannel_application_name: StrictStr = Field(..., description="Application's display Name.")
    verbose_name: StrictStr = Field(..., description="Return object's verbose_name")
    verbose_name_plural: StrictStr = Field(..., description="Return object's plural verbose_name")
    meta_model_name: StrictStr = Field(..., description="Return internal model name")
    settings: Optional[Any] = None
    outpost_set: conlist(StrictStr) = Field(...)
    connection_expiry: Optional[StrictStr] = Field(None, description="Determines how long a session lasts. Default of 0 means that the sessions lasts until the browser is closed. (Format: hours=-1;minutes=-2;seconds=-3)")
    delete_token_on_disconnect: Optional[StrictBool] = Field(None, description="When set to true, connection tokens will be deleted upon disconnect.")
    __properties = ["pk", "name", "authentication_flow", "authorization_flow", "property_mappings", "component", "assigned_application_slug", "assigned_application_name", "assigned_backchannel_application_slug", "assigned_backchannel_application_name", "verbose_name", "verbose_name_plural", "meta_model_name", "settings", "outpost_set", "connection_expiry", "delete_token_on_disconnect"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RACProvider:
        """Create an instance of RACProvider from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "pk",
                            "component",
                            "assigned_application_slug",
                            "assigned_application_name",
                            "assigned_backchannel_application_slug",
                            "assigned_backchannel_application_name",
                            "verbose_name",
                            "verbose_name_plural",
                            "meta_model_name",
                            "outpost_set",
                          },
                          exclude_none=True)
        # set to None if authentication_flow (nullable) is None
        # and __fields_set__ contains the field
        if self.authentication_flow is None and "authentication_flow" in self.__fields_set__:
            _dict['authentication_flow'] = None

        # set to None if settings (nullable) is None
        # and __fields_set__ contains the field
        if self.settings is None and "settings" in self.__fields_set__:
            _dict['settings'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RACProvider:
        """Create an instance of RACProvider from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RACProvider.parse_obj(obj)

        _obj = RACProvider.parse_obj({
            "pk": obj.get("pk"),
            "name": obj.get("name"),
            "authentication_flow": obj.get("authentication_flow"),
            "authorization_flow": obj.get("authorization_flow"),
            "property_mappings": obj.get("property_mappings"),
            "component": obj.get("component"),
            "assigned_application_slug": obj.get("assigned_application_slug"),
            "assigned_application_name": obj.get("assigned_application_name"),
            "assigned_backchannel_application_slug": obj.get("assigned_backchannel_application_slug"),
            "assigned_backchannel_application_name": obj.get("assigned_backchannel_application_name"),
            "verbose_name": obj.get("verbose_name"),
            "verbose_name_plural": obj.get("verbose_name_plural"),
            "meta_model_name": obj.get("meta_model_name"),
            "settings": obj.get("settings"),
            "outpost_set": obj.get("outpost_set"),
            "connection_expiry": obj.get("connection_expiry"),
            "delete_token_on_disconnect": obj.get("delete_token_on_disconnect")
        })
        return _obj


