# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictStr, conlist
from authentik_client.models.role_object_permission import RoleObjectPermission

class RoleAssignedObjectPermission(BaseModel):
    """
    Roles assigned object permission serializer  # noqa: E501
    """
    role_pk: StrictStr = Field(...)
    name: StrictStr = Field(...)
    permissions: conlist(RoleObjectPermission) = Field(...)
    __properties = ["role_pk", "name", "permissions"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RoleAssignedObjectPermission:
        """Create an instance of RoleAssignedObjectPermission from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "role_pk",
                            "name",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in permissions (list)
        _items = []
        if self.permissions:
            for _item in self.permissions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['permissions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RoleAssignedObjectPermission:
        """Create an instance of RoleAssignedObjectPermission from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RoleAssignedObjectPermission.parse_obj(obj)

        _obj = RoleAssignedObjectPermission.parse_obj({
            "role_pk": obj.get("role_pk"),
            "name": obj.get("name"),
            "permissions": [RoleObjectPermission.from_dict(_item) for _item in obj.get("permissions")] if obj.get("permissions") is not None else None
        })
        return _obj


