# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class SCIMProvider(BaseModel):
    """
    SCIMProvider Serializer  # noqa: E501
    """
    pk: StrictInt = Field(...)
    name: StrictStr = Field(...)
    property_mappings: Optional[conlist(StrictStr)] = None
    property_mappings_group: Optional[conlist(StrictStr)] = Field(None, description="Property mappings used for group creation/updating.")
    component: StrictStr = Field(..., description="Get object component so that we know how to edit the object")
    assigned_backchannel_application_slug: StrictStr = Field(..., description="Internal application name, used in URLs.")
    assigned_backchannel_application_name: StrictStr = Field(..., description="Application's display Name.")
    verbose_name: StrictStr = Field(..., description="Return object's verbose_name")
    verbose_name_plural: StrictStr = Field(..., description="Return object's plural verbose_name")
    meta_model_name: StrictStr = Field(..., description="Return internal model name")
    url: StrictStr = Field(..., description="Base URL to SCIM requests, usually ends in /v2")
    token: StrictStr = Field(..., description="Authentication token")
    exclude_users_service_account: Optional[StrictBool] = None
    filter_group: Optional[StrictStr] = None
    __properties = ["pk", "name", "property_mappings", "property_mappings_group", "component", "assigned_backchannel_application_slug", "assigned_backchannel_application_name", "verbose_name", "verbose_name_plural", "meta_model_name", "url", "token", "exclude_users_service_account", "filter_group"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SCIMProvider:
        """Create an instance of SCIMProvider from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "pk",
                            "component",
                            "assigned_backchannel_application_slug",
                            "assigned_backchannel_application_name",
                            "verbose_name",
                            "verbose_name_plural",
                            "meta_model_name",
                          },
                          exclude_none=True)
        # set to None if filter_group (nullable) is None
        # and __fields_set__ contains the field
        if self.filter_group is None and "filter_group" in self.__fields_set__:
            _dict['filter_group'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SCIMProvider:
        """Create an instance of SCIMProvider from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SCIMProvider.parse_obj(obj)

        _obj = SCIMProvider.parse_obj({
            "pk": obj.get("pk"),
            "name": obj.get("name"),
            "property_mappings": obj.get("property_mappings"),
            "property_mappings_group": obj.get("property_mappings_group"),
            "component": obj.get("component"),
            "assigned_backchannel_application_slug": obj.get("assigned_backchannel_application_slug"),
            "assigned_backchannel_application_name": obj.get("assigned_backchannel_application_name"),
            "verbose_name": obj.get("verbose_name"),
            "verbose_name_plural": obj.get("verbose_name_plural"),
            "meta_model_name": obj.get("meta_model_name"),
            "url": obj.get("url"),
            "token": obj.get("token"),
            "exclude_users_service_account": obj.get("exclude_users_service_account"),
            "filter_group": obj.get("filter_group")
        })
        return _obj


