# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from authentik_client.models.user_self import UserSelf

class SessionUser(BaseModel):
    """
    Response for the /user/me endpoint, returns the currently active user (as `user` property) and, if this user is being impersonated, the original user in the `original` property.  # noqa: E501
    """
    user: UserSelf = Field(...)
    original: Optional[UserSelf] = None
    __properties = ["user", "original"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SessionUser:
        """Create an instance of SessionUser from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        # override the default output from pydantic by calling `to_dict()` of original
        if self.original:
            _dict['original'] = self.original.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SessionUser:
        """Create an instance of SessionUser from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SessionUser.parse_obj(obj)

        _obj = SessionUser.parse_obj({
            "user": UserSelf.from_dict(obj.get("user")) if obj.get("user") is not None else None,
            "original": UserSelf.from_dict(obj.get("original")) if obj.get("original") is not None else None
        })
        return _obj


