# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, StrictInt, conlist, constr
from authentik_client.models.static_device_token import StaticDeviceToken

class StaticDevice(BaseModel):
    """
    Serializer for static authenticator devices  # noqa: E501
    """
    name: constr(strict=True, max_length=64) = Field(..., description="The human-readable name of this device.")
    token_set: conlist(StaticDeviceToken) = Field(...)
    pk: StrictInt = Field(...)
    __properties = ["name", "token_set", "pk"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> StaticDevice:
        """Create an instance of StaticDevice from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "token_set",
                            "pk",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in token_set (list)
        _items = []
        if self.token_set:
            for _item in self.token_set:
                if _item:
                    _items.append(_item.to_dict())
            _dict['token_set'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> StaticDevice:
        """Create an instance of StaticDevice from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return StaticDevice.parse_obj(obj)

        _obj = StaticDevice.parse_obj({
            "name": obj.get("name"),
            "token_set": [StaticDeviceToken.from_dict(_item) for _item in obj.get("token_set")] if obj.get("token_set") is not None else None,
            "pk": obj.get("pk")
        })
        return _obj


