# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr
from authentik_client.models.user_group import UserGroup
from authentik_client.models.user_type_enum import UserTypeEnum

class User(BaseModel):
    """
    User Serializer  # noqa: E501
    """
    pk: StrictInt = Field(...)
    username: constr(strict=True, max_length=150) = Field(...)
    name: StrictStr = Field(..., description="User's display name.")
    is_active: Optional[StrictBool] = Field(None, description="Designates whether this user should be treated as active. Unselect this instead of deleting accounts.")
    last_login: Optional[datetime] = None
    is_superuser: StrictBool = Field(...)
    groups: Optional[conlist(StrictStr)] = None
    groups_obj: conlist(UserGroup) = Field(...)
    email: Optional[constr(strict=True, max_length=254)] = None
    avatar: StrictStr = Field(..., description="User's avatar, either a http/https URL or a data URI")
    attributes: Optional[Dict[str, Any]] = None
    uid: StrictStr = Field(...)
    path: Optional[StrictStr] = None
    type: Optional[UserTypeEnum] = None
    uuid: StrictStr = Field(...)
    __properties = ["pk", "username", "name", "is_active", "last_login", "is_superuser", "groups", "groups_obj", "email", "avatar", "attributes", "uid", "path", "type", "uuid"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> User:
        """Create an instance of User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "pk",
                            "is_superuser",
                            "groups_obj",
                            "avatar",
                            "uid",
                            "uuid",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in groups_obj (list)
        _items = []
        if self.groups_obj:
            for _item in self.groups_obj:
                if _item:
                    _items.append(_item.to_dict())
            _dict['groups_obj'] = _items
        # set to None if last_login (nullable) is None
        # and __fields_set__ contains the field
        if self.last_login is None and "last_login" in self.__fields_set__:
            _dict['last_login'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> User:
        """Create an instance of User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return User.parse_obj(obj)

        _obj = User.parse_obj({
            "pk": obj.get("pk"),
            "username": obj.get("username"),
            "name": obj.get("name"),
            "is_active": obj.get("is_active"),
            "last_login": obj.get("last_login"),
            "is_superuser": obj.get("is_superuser"),
            "groups": obj.get("groups"),
            "groups_obj": [UserGroup.from_dict(_item) for _item in obj.get("groups_obj")] if obj.get("groups_obj") is not None else None,
            "email": obj.get("email"),
            "avatar": obj.get("avatar"),
            "attributes": obj.get("attributes"),
            "uid": obj.get("uid"),
            "path": obj.get("path"),
            "type": obj.get("type"),
            "uuid": obj.get("uuid")
        })
        return _obj


