# coding: utf-8

"""
    authentik

    Making authentication simple.

    The version of the OpenAPI document: 2024.2.2
    Contact: hello@goauthentik.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr

class UserGroupRequest(BaseModel):
    """
    Simplified Group Serializer for user's groups  # noqa: E501
    """
    name: constr(strict=True, max_length=80, min_length=1) = Field(...)
    is_superuser: Optional[StrictBool] = Field(None, description="Users added to this group will be superusers.")
    parent: Optional[StrictStr] = None
    attributes: Optional[Dict[str, Any]] = None
    __properties = ["name", "is_superuser", "parent", "attributes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UserGroupRequest:
        """Create an instance of UserGroupRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if parent (nullable) is None
        # and __fields_set__ contains the field
        if self.parent is None and "parent" in self.__fields_set__:
            _dict['parent'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UserGroupRequest:
        """Create an instance of UserGroupRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UserGroupRequest.parse_obj(obj)

        _obj = UserGroupRequest.parse_obj({
            "name": obj.get("name"),
            "is_superuser": obj.get("is_superuser"),
            "parent": obj.get("parent"),
            "attributes": obj.get("attributes")
        })
        return _obj


